#include<iostream>
#include<string>

using namespace std;


int main()
{
	int n;
	int o,a,b,ab;
	string pacijent[10000];
	int jedinice[10000];
	int donirane[10000][4];
	bool moguce = true;
	int s = 0;
	cin>>n;
	cin>>o>>a>>b>>ab;
	
	
	
	for(int i = 0; i < n; i++)
	{
		cin>>pacijent[i];
		cin>>jedinice[i];
		s+= jedinice[i];
	}
	
	if(o + a + b + ab < s)
	{
		cout<<"nemoguce";
		return 0;
	}
	
	for(int i = 0; i < n; i++)
	{
		if(pacijent[i] == "O")
		{
			if(jedinice[i] <= o)
			{
				int o1 = o;
				donirane[i][0] = o;
				o -= jedinice[i];
				jedinice[i] = 0;
				donirane[i][0] = o1 - o;
			}
			else
			{
				moguce = false;
				break;
					
			}
		}
		else if(pacijent[i] == "A")
		{
			if(jedinice[i] <= a)
			{
				int a1 = a;
				donirane[i][1] = a;
				a -= jedinice[i];
				jedinice[i] = 0;
				donirane[i][1] = a1 - a;
			}
			else if(jedinice[i] > a && jedinice[i] <= a + o)
			{
				donirane[i][1] = a;
				jedinice[i] -= a;
				a = 0;
				int o1 = o;
				o -= jedinice[i];
			
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
				
			}
			else
			{
				moguce = false;
				break;
			}
		}
		else if(pacijent[i] == "B")
		{
			if(jedinice[i] <= b)
			{
				int b1 = b;
				b -= jedinice[i];
				jedinice[i] = 0;
				donirane[i][2] = b1 - b;

				
			}
			else if(jedinice[i] > b && jedinice[i] <= b + o)
			{
				donirane[i][2] = b;
				jedinice[i] -= b;
				b = 0;
				int o1 = o;
				o -= jedinice[i];
				donirane[i][0] = o1 - o;
				jedinice[i] -= o1 - o; 
				cout<<jedinice[i];
			}
			else
			{
				moguce = false;
				break;
			}
		}
		else if(pacijent[i] == "AB")
		{
			if(jedinice[i] <= ab)
			{
				int ab1 = ab;
				ab -= jedinice[i];
				jedinice[i] = 0;
				donirane[i][3] = ab1 - ab;
			}
			else if(jedinice[i] <= a)
			{
				int a1 = a;
				a -= jedinice[i];
				jedinice[i] = 0;
				donirane[i][1] = a1 - a;
			}
			else if(jedinice[i] <= b)
			{
				int b1 = b;
				b -= jedinice[i];
				jedinice[i] = 0;
				donirane[i][2] = b1 - b;
			}
			else if(jedinice[i] <= o)
			{
				int o1 = o;
				o -= jedinice[i];
				jedinice[i] = 0;
				donirane[i][0] = o1 - o;
			}
			else if(jedinice[i] <= o + a)
			{
				donirane[i][1] = a;
				jedinice[i] -= a;
				a = 0;
				int o1 = o;
				o -= jedinice[i];
			
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
			}
			else if(jedinice[i] <= o + b)
			{
				donirane[i][2] = b;
				jedinice[i] -= b;
				b = 0;
				int o1 = o;
				o -= jedinice[i];
			
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
			}
			else if(jedinice[i] <= o + ab)
			{
				donirane[i][3] = ab;
				jedinice[i] -= ab;
				ab = 0;
				int o1 = o;
				o -= jedinice[i];
			
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
			}
			else if(jedinice[i] <= a + b)
			{
				donirane[i][1] = a;
				jedinice[i] -= a;
				a = 0;
				int b1 = b;
				b -= jedinice[i];
			
				jedinice[i] -= b1 - b;
				donirane[i][2] = b1 - b;
			}
			else if(jedinice[i] <= a + ab)
			{
				donirane[i][3] = ab;
				jedinice[i] -= ab;
				ab = 0;
				int a1 = a;
				a -= jedinice[i];
			
				jedinice[i] -= a1 - a;
				donirane[i][1] = a1 - a;
			}
			else if(jedinice[i] <= b + ab)
			{
				donirane[i][3] = ab;
				jedinice[i] -= ab;
				ab = 0;
				int b1 = b;
				b -= jedinice[i];
			
				jedinice[i] -= b1 - b;
				donirane[i][2] = b1 - b;
			}
			else if(jedinice[i] <= a + b + ab)
			{
				donirane[i][3] = ab;
				jedinice[i] -= ab;
				ab = 0;
				donirane[i][1] = a;
				jedinice[i] -= a;
				a = 0;
			
				int b1 = b;
				b -= jedinice[i];
				
				jedinice[i] -= b1 - b;
				donirane[i][2] = b1 - b;
			}
			
			else if(jedinice[i] <= a + o + ab)
			{
				donirane[i][3] = ab;
				jedinice[i] -= ab;
				ab = 0;
				donirane[i][1] = a;
				jedinice[i] -= a;
				a = 0;
			
				int o1 = o;
				o -= jedinice[i];
				
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
			}
			else if(jedinice[i] <= b + o + ab)
			{
				donirane[i][3] = ab;
				jedinice[i] -= ab;
				ab = 0;
				donirane[i][2] = b;
				jedinice[i] -= b;
				b = 0;
			
				int o1 = o;
				o -= jedinice[i];
				
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
			}
			else if(jedinice[i] <= a + b + o)
			{
				donirane[i][1] = a;
				jedinice[i] -= a;
				a = 0;
				donirane[i][2] = b;
				jedinice[i] -= b;
				b = 0;
				int o1 = o;
				o -= jedinice[i];
				
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
			}
			else if(jedinice[i] <= a + b + ab + o)
			{
				donirane[i][1] = a;
				jedinice[i] -= a;
				a = 0;
				donirane[i][2] = b;
				jedinice[i] -= b;
				b = 0;
				donirane[i][3] = ab;
				jedinice[i] -= ab;
				ab = 0;
				int o1 = o;
				o -= jedinice[i];
				
				jedinice[i] -= o1 - o;
				donirane[i][0] = o1 - o;
			}
			else
			{
				moguce = false;
				break;
			}
			cout<<o<<" "<<a<<" "<<b<<" "<<ab<<endl;
		}
	}
	
		if(moguce)
		{
			cout<<"moguce"<<endl;
			for(int i = 0; i < n; i++)
			{
				cout<<donirane[i][0]<<" "<<donirane[i][1]<<" "<<donirane[i][2]<<" "<<donirane[i][3]<<endl;
			}
		
		}
		else
		{
			cout<<"nemoguce";
		}
	
	return 0;
}